"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
function scrapeUserId(page) {
    return tslib_1.__awaiter(this, void 0, void 0, function* () {
        const topLevelMenuLinks = yield page.$$eval('nav.siteHeader__primaryNavInline a.siteHeader__topLevelLink', anchors => anchors.map(anchor => anchor.getAttribute('href')));
        return topLevelMenuLinks[1].split('/').slice(-1)[0];
    });
}
exports.scrapeUserId = scrapeUserId;
function listbooks(page) {
    return tslib_1.__awaiter(this, void 0, void 0, function* () {
        const userId = yield scrapeUserId(page);
        const url = `https://www.goodreads.com/notes/${userId}/load_more`;
        const [response] = yield Promise.all([
            page.waitForResponse(url),
            page.goto(url),
        ]);
        const rawJson = (yield response.json());
        return rawJson.annotated_books_collection.map(book => ({
            asin: book.asin,
            title: book.title,
            author: book.authorName,
            imageUrl: book.imageUrl,
            bookUrl: book.readingNotesUrl,
        }));
    });
}
exports.default = listbooks;
//# sourceMappingURL=listbooks.js.map